#pragma once
//  ACLMorphRequest
//
//  This class extends the standard DXRequest class to carry additional information needed by the
//  DbACLMorph processing exit and the AppTransactionHandler.
//
//  Message Identifier:      N/A
//  Message Range:           0000 - 0000
//  Trace area assignment:   None
//  Version:                 1.0.3  Build: 38
//
//  Version History:
//
//  1.0.0		14/10/2010		Base Release
//  1.0.3		22/10/2011		VS 2011 Updates
//
//  Copyright: Hadleigh Marshall (Netherlands) b.v. 2010 - 2011
//

//  Runtime Includes
#include "../DXCommon/MTDX/DXRequest.h"
#include "../DXCommon/ACL/DXACLRuleSet.h"

class ACLMorphRequest :
	public DXRequest
{
public:
	//  Default Constructor
	ACLMorphRequest(void);

	//  Destructor
	~ACLMorphRequest(void);

	//  Public Members
	NOTEID				nidTX;								//  Note ID of the originating Transaction
	DXACLRuleSet		*acrTransform;						//  The ACL Rule set to use for transformations
	HANDLE				hTXLog;								//  Handle to the transaction log
	DWORD				dwDbsUpdated;						//  D/B ACLs Updated
	TIMEDATE			tdUpdateStarted;					//  Timestamp that the transaction started
	char				TransID[MAX_DATABASE + 1];			//  Transaction Identifier

	//  Public Functions
	using DXRequest::InheritFrom;
	using DXRequest::CreateNewInstance;
	using DXRequest::PromoteScores;
	virtual DXRequest * CreateNewInstance(void);			//  Create a new instance
	virtual void InheritFrom(DXRequest *dxrParent);			//  Inherit context from parent request
	virtual void PromoteScores(DXRequest *dxrParent);		//  Promote scores to parent request
};
