// QACLMorph.h : Header for the Queue Driven ACL Transformer

//  Platform Includes
#include	"../DXCommon/Platform/PlatBase.h"				//  Basic platform includes

//  Runtime Includes
#include	"../DXCommon/MTX/MTExecutive.h"					//  Multi-Threading Runtime Environment
#include	"../DXCommon/MTDX/DominoExplorer.h"				//  Domino Explorer (DX)
#include	"../DXCommon/ACL/DXACLRuleSetParser.h"			//  DX ACL Rule Set Parser
#ifdef _DEBUG
#include	"../DXCommon/Debug/Helper.h"					//  Debug helper
#endif

//  Application Includes
#include	"AppRunSettings.h"								//  Run Settings
#include	"AppCommandHandler.h"							//  MQ Command Handler
#include	"AppTransactionHandler.h"						//  Transaction Queue Handler
#include	"DbACLMorpher.h"								//  Database ACL Morpher

//  Identification Constants
#define		APP_NAME			"QACLMorph"
#define		APP_TITLE			"ACL Transformer"
#ifdef _DEBUG
#define		APP_VERSION			"1.0.5 build: 42 Debug"
#else
#define		APP_VERSION			"1.0.5 build: 42"
#endif
#define		ACMQNAME			"ACL Morph Queue #1"		//  Transaction Queue Name

//  Application Constants

//  Transaction View Names
//  Queue Names
#define		QUEUE_NEW_TRANS_VIEW		"NewTransactions"
#define		QUEUE_DELAYED_TRANS_VIEW	"DelayedTransactions"
#define		QUEUE_IP_TRANS_VIEW			"InProgressTransactions"

//  Return codes
#define		APPRC_NOERROR		0				//  Everything copacetic
#define		APPRC_WARN			4				//  Execution ok, but warnings issued
#define		APPRC_ERROR			8				//  Execution completed with errors
#define		APPRC_FATAL			16				//  Execution could not be completed

//  Wait, timeout and other intervals and limits
#define		TIMEOUT_EVENT_WAIT	5000			//  5 seconds delay in idle state

//  Miscellaneous definitions
#define		PCAP_PERTHREAD		20				//  Allow capacity for 20 pending requests per thread
#define		RCAP_PERTHREAD		20				//  Allow capacity for 20 rejoin requests per thread
#define		ADDIN_STATUS_RUNNING		"Running"
#define		ADDIN_STATUS_TERM			"Shutting Down"

//  Error Messages
#define		MSG_QAM0101S		"QAM0101S: Unable to start program execution."
#define		MSG_QAM0103S		"QAM0103S: Unable to close the application execution environment."
#define		MSG_QAM0104E		"QAM0104E: Failed to initialise a Domino Explorer."
#define		MSG_QAM0106S		"QAM0106S: Unable to initialise multi-threaded operations."

//  Information Messages
#define		MSG_QAM0102I		"QAM0102I: Using Runtime Version: %s."
#define		MSG_QAM0105I		"QAM0105I: Transaction queue '%s' has drained."
#define		MSG_QAM0107I		"QAM0107I: QACLMorph has recieved a Quit signal from the message queue."
#define		MSG_QAM0108I		"QAM0108I: QACLMorph is shutting down."
